const path = require('path');

module.exports = {
    mode: 'production',
    entry:{
        main: './src/index.js'
    },
    //externals 用于从输出的 bundle 中排除依赖，可以减小bundle的大小，并防止应用程序重复应用这些依赖。
    //相应的，输出的 bundle 在运行时需要从外部应用程序中获取这些被排除的依赖。
    externals:{
        //这里 lodash 这个外部 library 可以在 AMD 和 CommonJS 模块系统中通过 lodash 访问，但在全局变量形式下通过 _ 访问。
        lodash:{
            amd: 'lodash',
            commonjs: 'lodash',
            commonjs2: 'lodash',
            root: '_'
        },
        jquery: 'jQuery'
    },
    output:{
        path: path.resolve(__dirname,'./dist'),
        filename: 'yoho-base.js',
        //支持script的引用，并暴露为全局变量yoho-base。
        library: 'yohoBase',
        //支持ES Module、Commonjs、AMD的引用。
        libraryTarget: 'umd',
    }
};